// don't want this executing when building graphs
if($OFFLINE_NAV_BUILD)
   return;


// Script for Backup Generator Support
// Writen by:  t-b0n3
// Date:  August 9, 2001
// Support: timcbaker@home.com    -- but don't spam me, dammit!  :)

activatePackage(BackupGeneratorInit);

//Initiallize Game Variables.  Pretty simple
game.Team1PrimaryGen = nameToId("Team1PrimaryGen");
game.Team1BackupGen = nameToID("Team1BackupGen");
game.Team2PrimaryGen = nameToId("Team2PrimaryGen");
game.Team2BackupGen = nameToID("Team2BackupGen");
game.Team0PrimaryGen = nameToId("Team0PrimaryGen");
game.Team0BackupGen = nameToID("Team0BackupGen");

//BackupGen.PrimaryState is the state of the backup generators primary generator.  1 = up, 0 = down.
game.Team1BackupGen.PrimaryState = "1";
game.Team2BackupGen.PrimaryState = "1";
game.Team0BackupGen.PrimaryState = "1";

//BackupGen.BackupState is the state of the backup generator itself.  1 = up, 0 = down.
game.Team1BackupGen.BackupState = "1";
game.Team2BackupGen.BackupState = "1";
game.Team0BackupGen.BackupState = "1";



//Declare the following variable in your .mis file, or, you can add it here yourself, and not have it in the .mis

//  game.GenBackupTime   <--- The delay, in seconds, between primary powerdown and backup powerup.
//  if not declared elsewhere, game.GenBackupTime will be 30 seconds.

if (game.GenBackupTime $= "")
    game.GenBackupTime = 30;
    
package BackupGeneratorInit {
//====== Begin the BackupGeneratorInit Package ==========================


   function Generator::onDisabled(%data, %obj, %prevState)
   {
       %obj.decPowerCount();
      if (%obj == game.Team1PrimaryGen)
      {
         game.Team1BackupGen.PrimaryState = "0";  //set the PrimaryState to 0 (off)
       if (game.Team1BackupGen.BackupState $= "1")
         {
         game.Team1BackupGen.Timer = schedule(game.GenBackupTime * 1000, 0, InitBackupGen, game.Team1BackupGen);  //Schedule the backup generator to turn on.
         }
      }
      if (%obj == game.Team2PrimaryGen)
      {
         //%obj.decPowerCount();
         game.Team2BackupGen.PrimaryState = "0";  //set the PrimaryState to 0 (off)
       if (game.Team2BackupGen.BackupState $= "1")
         {
         game.Team2BackupGen.Timer = schedule(game.GenBackupTime * 1000, 0, InitBackupGen, game.Team2BackupGen);  //Schedule the backup generator to turn on.
         }
      }
      if (%obj == game.Team0PrimaryGen)
      {
        // %obj.decPowerCount();
         game.Team0BackupGen.PrimaryState = "0";  //set the PrimaryState to 0 (off)
       if (game.Team0BackupGen.BackupState $= "1")
         {
         game.Team0BackupGen.Timer = schedule(game.GenBackupTime * 1000, 0, InitBackupGen, game.Team0BackupGen);  //Schedule the backup generator to turn on.
         }
      }

      if (%obj == game.Team1BackupGen)
       {
         if (game.Team1BackupGen.PrimaryState $= "1")
         {
         %obj.incPowerCount();
         }
         game.Team1BackupGen.BackupState = "0";  //This is so we can tell if this generator has been disabled. (Fired at)
       }
         
      if (%obj == game.Team2BackupGen)
       {
         if (game.Team2BackupGen.PrimaryState $= "1")
         {
         %obj.incPowerCount();
         }
         game.Team2BackupGen.BackupState = "0";  //This is so we can tell if this generator has been disabled. (Fired at)
       }
         
      if (%obj == game.Team0BackupGen)
       {
         if (game.Team0BackupGen.PrimaryState $= "1")
         {
         %obj.incPowerCount();
         }
         game.Team0BackupGen.BackupState = "0";  //This is so we can tell if this generator has been disabled. (Fired at)
       }
         
      Parent::onDisabled(%data, %obj, %prevState);  //Run the default onDisabled function
   }

   function Generator::onEnabled(%data, %obj, %prevState)
   {
      %obj.incPowerCount();

      if (%obj == game.Team1PrimaryGen)
      {
         game.Team1BackupGen.PrimaryState = "1";  //The Primary gen has come up.
         cancel(Team1BackupGen.Timer);            //If the primary gen is repaired before the backup gen comes on, stop the scheduled initialization.
         ShutdownBackupGen(game.Team1BackupGen);  //Run the shutdown script for the specified backup gen.
      }
      if (%obj == game.Team2PrimaryGen)
      {
         game.Team2BackupGen.PrimaryState = "1";  //The Primary gen has come up.
         cancel(Team2BackupGen.Timer);            //If the primary gen is repaired before the backup gen comes on, stop the scheduled initialization.
         ShutdownBackupGen(game.Team2BackupGen);  //Run the shutdown script for the specified backup gen.
      }
      if (%obj == game.Team0PrimaryGen)
      {
         game.Team0BackupGen.PrimaryState = "1";  //The Primary gen has come up.
         cancel(Team0BackupGen.Timer);            //If the primary gen is repaired before the backup gen comes on, stop the scheduled initialization.
         ShutdownBackupGen(game.Team0BackupGen);  //Run the shutdown script for the specified backup gen.
      }

      if (%obj == game.Team1BackupGen)
      {
         game.Team1BackupGen.BackupState = "1";   //If the BackupGen is repaired, check the state of the primary gen.  If primary is on, do not run the onEnable functions.
         if (game.Team1BackupGen.PrimaryState $= "1")
            {
            return;
            }
         InitBackupGen(game.Team1BackupGen);
      }

      if (%obj == game.Team2BackupGen)
      {
         game.Team2BackupGen.BackupState = "1";   //If the BackupGen is repaired, check the state of the primary gen.  If primary is on, do not run the onEnable functions.
         if (game.Team2BackupGen.PrimaryState $= "1")
           {
            return;
           }
         InitBackupGen(game.Team2BackupGen);
      }

      if (%obj == game.Team0BackupGen)
      {
         game.Team0BackupGen.BackupState = "1";   //If the BackupGen is repaired, check the state of the primary gen.  If primary is on, do not run the onEnable functions.
         if (game.Team0BackupGen.PrimaryState $= "1")
            {
            return;
            }
         InitBackupGen(game.Team0BackupGen);
      }
      
      Parent::onEnabled(%data, %obj, %prevState);  //Run the default onEnabled function, if not returned previously.
   }  

   function DefaultGame::missionLoadDone(%game)  //This function is taken out of DefaultGame.cs.  We need it to shut down the generators after the SimGroup::powerInit function.
   {
      //  walks through the mission group and sets the power stuff up
      //   - groups get initialized with power count 0 then iterated to 
      //     increment powercount if an object within is powered
      //   - powers objects up/down
      //MissionGroup.objectiveInit();
      MissionGroup.clearPower();
      MissionGroup.powerInit(0);

      %game.initGameVars();  //set up scoring variables and other game specific globals

      // make team0 visible/friendly to all
      setSensorGroupAlwaysVisMask(0, 0xffffffff);
      setSensorGroupFriendlyMask(0, 0xffffffff);

      // update colors:
      // - enemy teams are red
      // - same team is green
      // - team 0 is white
      for(%i = 0; %i < 32; %i++)
      {
         %team = (1 << %i);
         setSensorGroupColor(%i, %team, "0 255 0 255");
         setSensorGroupColor(%i, ~%team, "255 0 0 255");
         setSensorGroupColor(%i, 1, "255 255 255 255");

         // setup the team targets (alwyas friendly and visible to same team)
         setTargetAlwaysVisMask(%i, %team);
         setTargetFriendlyMask(%i, %team);
      }

      //set up the teams
      %game.setUpTeams();

      //clear out the team rank array...
      for (%i = 0; %i < 32; %i++)
         $TeamRank[%i, count] = "";

      // objectiveInit has to take place after setupTeams -- objective HUD relies on flags
      // having their team set
      MissionGroup.objectiveInit();

      //initialize the AI system
      %game.aiInit();
   
      //need to reset the teams if we switch from say, CTF to Bounty...
      // assign the bots team
      if ($currentMissionType !$= $previousMissionType)
      {
         $previousMissionType = $currentMissionType;
         for(%i = 0; %i < ClientGroup.getCount(); %i++)
         {
            %cl = ClientGroup.getObject(%i);
            if (%cl.isAIControlled())
               %game.assignClientTeam(%cl);
         }
      }
   
      //Save off respawn or Siege Team switch information...
      if(%game.class !$= "SiegeGame")
         MissionGroup.setupPositionMarkers(true);
      echo("Default game mission load done.");

      MissionStartShutdownBackupGen(game.Team1BackupGen);  //Shutdown the specified generator after the mission finishes loading
      MissionStartShutdownBackupGen(game.Team2BackupGen);  //Shutdown the specified generator after the mission finishes loading
      MissionStartShutdownBackupGen(game.Team0BackupGen);  //Shutdown the specified generator after the mission finishes loading
   }

};

// End of the BackupGeneratorInit package


function InitBackupGen(%GeneratorID)  //Self proclaimed function to initialize the backup generator
{
   if (%GeneratorID.PrimaryState $= "0" && %GeneratorID.BackupState $= "1")  //If the primary gen is down, and the backup gen is at least operable (not damaged too badly), then continue.
   {
      %GeneratorID.powerInit(1);  //Initialize power on the generator
      %GeneratorID.incPowerCount();  //Increase the Powercount variable in the simgroup.  Otherwise, the lights will come on, but nobody will be home...
      %GenTeam = %GeneratorID.team;  //Set %GenTeam to the team that owns the specified generator.
      messageteam(%GenTeam, 'BackupGenOnline', '\c1The backup generator is online.~wfx/misc/warning_beep.wav');  //Issue a message to the generators team, and beep.
   }
}
   
   
   
function ShutdownBackupGen(%GeneratorID)  //Self proclaimed function to shut down the backup generator.
{
   if (%GeneratorID.isPowered() == 1)  //Check to make sure that the generator is actually powered before trying to shut it down, so as not to screw up the powerCount in the simgroup.
   {
      %GeneratorID.getdatablock().losepower(%GeneratorID);  //Shut the power down on the generator.
      %GeneratorID.decPowerCount();  //Decrease the PowerCount on the simgroup.
      %GeneratorID.decPowerCount();
      %GenTeam = %GeneratorID.team;  //Set %GenTeam to the team that owns the specified generator.
      if (%GeneratorID.BackupState $= "1")
       {
       messageteam(%GenTeam, 'BackupGenOffline', '\c1Primary generator repaired.  The backup generator is offline.~wfx/misc/warning_beep.wav'); //Issue a message to the generators team, and beep.
       }
   }
}

function MissionStartShutdownBackupGen(%GeneratorID)  //Self proclaimed function to shut down the backup generator after the mission finishes loading.
{
   %GeneratorID.getdatablock().losepower(%GeneratorID);  //Shut down the gen
   //%GeneratorID.decPowerCount();  //decrease the powercount of the simgroup the gen belongs to.
}


